package com.jiuqi.db;

import com.jiuqi.db.impl.DB2DBMetaData;
import com.jiuqi.db.impl.MySQLDBMetaData;
import com.jiuqi.db.impl.OracleDBMetaData;
import com.jiuqi.db.impl.SQLServerDBMetaData;
import com.jiuqi.db.impl.SybaseDBMetaData;
import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.SQLException;

public class DBMetaDataFactory {
   public static DBMetaData initDBMetaData(Connection conn) throws SQLException {
      DatabaseMetaData dbmd = conn.getMetaData();
      String dbname = dbmd.getDatabaseProductName().toLowerCase();
      if (dbname.indexOf("sqlserver") == -1 && dbname.indexOf("sql server") == -1) {
         if (dbname.indexOf("oracle") != -1) {
            return new OracleDBMetaData(dbmd);
         } else if (dbname.indexOf("db2") != -1) {
            return new DB2DBMetaData(dbmd);
         } else if (dbname.indexOf("adaptive") == -1 && dbname.indexOf("sybase") == -1) {
            return dbname.indexOf("mysql") != -1 ? new MySQLDBMetaData(dbmd) : null;
         } else {
            return new SybaseDBMetaData(dbmd);
         }
      } else {
         return new SQLServerDBMetaData(dbmd);
      }
   }
}
